diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
index 06d0e3f6d5..0c1e03f044 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
@@ -1226,60 +1362,82 @@ alloc_iq_fl(struct port_info *pi, struct sge_iq *iq, struct sge_fl *fl,
 		    X_FETCHBURSTMIN_64B_T6: X_FETCHBURSTMIN_128B;
 		const uint_t fbmax = t4_cver_ge(sc, CHELSIO_T6) ?
 		    X_FETCHBURSTMAX_256B : X_FETCHBURSTMAX_512B;
-		c.fl0dcaen_to_fl0cidxfthresh = cpu_to_be16(
+		const uint32_t fl_cong = (tip->tip_cong_chan == -1) ? 0 :
+		    (V_FW_IQ_CMD_FL0CNGCHMAP(tip->tip_cong_chan) |
+		    F_FW_IQ_CMD_FL0CONGCIF |
+		    F_FW_IQ_CMD_FL0CONGEN);
+
+		iq_cmd.iqns_to_fl0congen |= BE_32(
+		    V_FW_IQ_CMD_FL0HOSTFCMODE(X_HOSTFCMODE_NONE) |
+		    F_FW_IQ_CMD_FL0PACKEN |
+		    F_FW_IQ_CMD_FL0PADEN |
+		    fl_cong);
+		/*
+		 * We do not set cidx flushing because we choose to have no cidx
+		 * updates for an FL. Instead we track FL usage implicitly by
+		 * the incoming CPL messages on the Rx IQ.
+		 */
+		iq_cmd.fl0dcaen_to_fl0cidxfthresh |= BE_16(
 		    V_FW_IQ_CMD_FL0FBMIN(fbmin) |
 		    V_FW_IQ_CMD_FL0FBMAX(fbmax));
-		c.fl0size = cpu_to_be16(fl->qsize);
-		c.fl0addr = cpu_to_be64(fl->ba);
+		iq_cmd.fl0size |= BE_16(eq->tse_qsize_spg);
+		iq_cmd.fl0addr |= BE_64(eq->tse_ring_ba);
+	}
+	if (!intr_fwd) {
+		iq->tsi_flags |= IQ_INTR;
 	}
 
-	rc = -t4_wr_mbox(sc, sc->mbox, &c, sizeof (c), &c);
+	rc = -t4_wr_mbox(sc, sc->mbox, &iq_cmd, sizeof (iq_cmd), &iq_cmd);
 	if (rc != 0) {
 		cxgb_printf(sc->dip, CE_WARN,
 		    "failed to create ingress queue: %d", rc);
+		t4_free_iq(pi, iq);
 		return (rc);
 	}
+	iq->tsi_cntxt_id = BE_16(iq_cmd.iqid);
+	iq->tsi_abs_id = BE_16(iq_cmd.physiqid);
+	iq->tsi_flags |= IQ_ALLOC_DEV;
 
-	iq->cdesc = iq->desc;
-	iq->cidx = 0;
-	iq->gen = 1;
-	iq->adapter = sc;
-	iq->cntxt_id = be16_to_cpu(c.iqid);
-	iq->abs_id = be16_to_cpu(c.physiqid);
-	iq->flags |= IQ_ALLOCATED;
-	mutex_init(&iq->lock, NULL, MUTEX_DRIVER,
-	    DDI_INTR_PRI(DDI_INTR_PRI(sc->intr_pri)));
-	iq->polling = 0;
+	iq->tsi_cdesc = iq->tsi_desc;
+	iq->tsi_cidx = 0;
+	iq->tsi_gen = F_RSPD_GEN;
+	iq->tsi_adapter = sc;
 
-	*t4_iqmap_slot(sc, iq->cntxt_id) = iq;
+	*t4_iqmap_slot(sc, iq->tsi_cntxt_id) = iq;
 
 	if (fl != NULL) {
-		fl->cntxt_id = be16_to_cpu(c.fl0id);
-		fl->pidx = fl->cidx = 0;
+		t4_sge_eq_t *eq = &fl->eq;
+
+		eq->tse_cntxt_id = BE_16(iq_cmd.fl0id);
+
+		CTASSERT(offsetof(struct sge_fl, eq) == 0);
+		*t4_eqmap_slot(sc, eq->tse_cntxt_id) = (t4_sge_eq_t *)fl;
+		eq->tse_flags |= EQ_ALLOC_DEV;
+		eq->tse_pidx = eq->tse_cidx = 0;
+		t4_alloc_eq_post(pi, eq);
 		fl->copy_threshold = rx_copy_threshold;
 
-		*t4_eqmap_slot(sc, fl->cntxt_id) = (struct sge_eq *)fl;
+		/* Allocate space for one software descriptor per buffer. */
+		const size_t sdesc_sz = fl->bufs_cap * sizeof (struct fl_sdesc);
+		fl->sdesc = kmem_zalloc(sdesc_sz, KM_SLEEP);
+		eq->tse_flags |= EQ_ALLOC_DESC;
 
 		FL_LOCK(fl);
-		(void) refill_fl(sc, fl, fl->lowat);
+		(void) t4_fl_refill(fl, fl->bufs_lowat);
 		FL_UNLOCK(fl);
-
-		iq->flags |= IQ_HAS_FL;
 	}
 
-	if (t4_cver_ge(sc, CHELSIO_T5) && cong >= 0) {
-		uint32_t param, val;
-
-		param = V_FW_PARAMS_MNEM(FW_PARAMS_MNEM_DMAQ) |
+	if (t4_cver_ge(sc, CHELSIO_T5) && tip->tip_cong_chan != -1) {
+		const uint32_t param = V_FW_PARAMS_MNEM(FW_PARAMS_MNEM_DMAQ) |
 		    V_FW_PARAMS_PARAM_X(FW_PARAMS_PARAM_DMAQ_CONM_CTXT) |
-		    V_FW_PARAMS_PARAM_YZ(iq->cntxt_id);
-		if (cong == 0)
-			val = 1 << 19;
-		else {
-			val = 2 << 19;
-			for (i = 0; i < 4; i++) {
-				if (cong & (1 << i))
-					val |= 1 << (i << 2);
+		    V_FW_PARAMS_PARAM_YZ(iq->tsi_cntxt_id);
+
+		const uint_t congmap_log = sc->params.arch.cng_ch_bits_log;
+		uint32_t val =
+		    V_CONMCTXT_CNGTPMODE(X_CONMCTXT_CNGTPMODE_CHANNEL);
+		for (uint_t i = 0; i < 4; i++) {
+			if (tip->tip_cong_chan & (1 << i)) {
+				val |= (1 << (i << congmap_log));
 			}
 		}
 
@@ -1288,137 +1446,283 @@ alloc_iq_fl(struct port_info *pi, struct sge_iq *iq, struct sge_fl *fl,
 			/* report error but carry on */
 			cxgb_printf(sc->dip, CE_WARN,
 			    "failed to set congestion manager context for "
-			    "ingress queue %d: %d", iq->cntxt_id, rc);
+			    "ingress queue %d: %d", iq->tsi_cntxt_id, rc);
 		}
 	}
 
-	/* Enable IQ interrupts */
-	iq->state = IQS_IDLE;
-	t4_iq_gts_update(iq, iq->intr_params, 0);
+	/* Enable event (and firmware) queues IQs immediately */
+	if (iq->tsi_iqtype == TIQT_EVENT) {
+		iq->tsi_flags |= IQ_ENABLED;
+		t4_iq_gts_update(iq, iq->tsi_gts_rearm, 0);
+	}
 
 	return (0);
 }
 
-static int
-free_iq_fl(struct port_info *pi, struct sge_iq *iq, struct sge_fl *fl)
+static void
+t4_free_iq(struct port_info *pi, t4_sge_iq_t *iq)
 {
-	int rc;
+	struct adapter *sc = iq->tsi_adapter;
+	struct sge_fl *fl = iq->tsi_fl;
+	t4_sge_eq_t *eq = fl != NULL ? &fl->eq : NULL;
 
-	if (iq != NULL) {
-		struct adapter *sc = iq->adapter;
-		dev_info_t *dip;
-
-		dip = pi ? pi->dip : sc->dip;
-		if (iq->flags & IQ_ALLOCATED) {
-			rc = -t4_iq_free(sc, sc->mbox, sc->pf, 0,
-			    FW_IQ_TYPE_FL_INT_CAP, iq->cntxt_id,
-			    fl ? fl->cntxt_id : 0xffff, 0xffff);
-			if (rc != 0) {
-				cxgb_printf(dip, CE_WARN,
-				    "failed to free queue %p: %d", iq, rc);
-				return (rc);
-			}
-			mutex_destroy(&iq->lock);
-			iq->flags &= ~IQ_ALLOCATED;
-		}
+	/*
+	 * The onus is placed on the caller to ensure that no further activity
+	 * will occur on this IQ.
+	 */
+	iq->tsi_flags &= ~IQ_ENABLED;
 
-		if (iq->desc != NULL) {
-			(void) free_desc_ring(&iq->dhdl, &iq->ahdl);
-			iq->desc = NULL;
-		}
+	if (iq->tsi_flags & IQ_ALLOC_DEV) {
+		/*
+		 * Device-side resources of freelists are allocated in concert
+		 * with the device-side resources of their associated IQ.
+		 */
+		ASSERT(fl == NULL || (eq->tse_flags & EQ_ALLOC_DEV));
 
-		bzero(iq, sizeof (*iq));
+		const uint16_t eq_cntxid = fl ? eq->tse_cntxt_id : 0xffff;
+		int rc = -t4_iq_free(sc, sc->mbox, sc->pf, 0,
+		    FW_IQ_TYPE_FL_INT_CAP, iq->tsi_cntxt_id, eq_cntxid, 0xffff);
+		if (rc != 0) {
+			cxgb_printf(sc->dip, CE_WARN,
+			    "failed to free IQ/FL (%x/%x): %d",
+			    iq->tsi_cntxt_id, eq_cntxid, rc);
+			/* attempt to complete the rest of clean-up */
+		}
+		iq->tsi_flags &= ~IQ_ALLOC_DEV;
+		if (fl != NULL) {
+			eq->tse_flags &= ~EQ_ALLOC_DEV;
+		}
 	}
+	if (iq->tsi_flags & IQ_ALLOC_HOST) {
+		(void) free_desc_ring(&iq->tsi_desc_dhdl, &iq->tsi_desc_ahdl);
+		iq->tsi_desc = NULL;
+		iq->tsi_cdesc = NULL;
+		iq->tsi_desc_ba = 0;
+		mutex_destroy(&iq->tsi_lock);
+		iq->tsi_flags &= ~IQ_ALLOC_HOST;
+	}
+	iq->tsi_flags &= ~IQ_INTR;
+	ASSERT0(iq->tsi_flags);
+
+	iq->tsi_intr_idx = 0;
+	iq->tsi_intr_evtq = NULL;
+	iq->tsi_iqtype = TIQT_UNINIT;
 
 	if (fl != NULL) {
-		if (fl->sdesc != NULL) {
+		if (eq->tse_flags & EQ_ALLOC_DESC) {
 			FL_LOCK(fl);
-			free_fl_bufs(fl);
+			t4_fl_free_bufs(fl);
 			FL_UNLOCK(fl);
 
-			kmem_free(fl->sdesc, sizeof (struct fl_sdesc) *
-			    fl->cap);
+			kmem_free(fl->sdesc, fl->bufs_cap *
+			    sizeof (struct fl_sdesc));
 			fl->sdesc = NULL;
+
+			eq->tse_flags &= ~EQ_ALLOC_DESC;
 		}
+		t4_free_eq(pi, eq);
+		iq->tsi_fl = NULL;
+
+		ASSERT0(eq->tse_flags);
+	}
+}
+
+int
+t4_alloc_evt_iqs(struct adapter *sc)
+{
+	const t4_intr_plan_t plan = sc->intr_queue_cfg.intr_plan;
+
+	const t4_iq_params_t fwq_iqp = {
+		.tip_iq_type	= TIQT_EVENT,
+		.tip_tmr_idx	= sc->sge.fwq_tmr_idx,
+		.tip_pktc_idx	= sc->sge.fwq_pktc_idx,
+		.tip_qsize	= FW_IQ_QSIZE,
+		.tip_esize	= FW_IQ_ESIZE,
+		.tip_cong_chan	= -1,
+		.tip_intr_evtq	= NULL,
+		/*
+		 * The device error-handling interrupt always occupies the 0th
+		 * slot, which the firmware queue will share if no additional
+		 * interrupts are available.  Otherwise it uses the next slot
+		 * after that.
+		 */
+		.tip_intr_idx	= (plan == TIP_SINGLE) ? 0 : 1,
+	};
+	const int rc = t4_alloc_iq(sc->port[0], &fwq_iqp, &sc->sge.fwq, NULL);
+	if (rc != 0) {
+		cxgb_printf(sc->dip, CE_WARN,
+		    "failed to create firmware event queue: %d.", rc);
+		return (rc);
+	}
 
-		if (fl->desc != NULL) {
-			(void) free_desc_ring(&fl->dhdl, &fl->ahdl);
-			fl->desc = NULL;
+	if (plan == TIP_PER_PORT) {
+		const uint_t ipp = sc->intr_queue_cfg.intr_per_port;
+		const uint_t port_count = sc->params.nports;
+
+		for (uint_t i = 0; i < port_count; i++) {
+			struct port_info *port = sc->port[i];
+
+			for (uint_t j = 0; j < ipp; j++) {
+				const t4_iq_params_t iqp = {
+					.tip_iq_type	= TIQT_EVENT,
+					.tip_tmr_idx	= sc->sge.fwq_tmr_idx,
+					.tip_pktc_idx	= sc->sge.fwq_pktc_idx,
+					.tip_qsize	= FW_IQ_QSIZE,
+					.tip_esize	= FW_IQ_ESIZE,
+					.tip_cong_chan	= -1,
+					.tip_intr_evtq	= NULL,
+					.tip_intr_idx	= 2 + (i * ipp) + j,
+				};
+
+				const int rc = t4_alloc_iq(port, &iqp,
+				    &port->intr_iqs[j], NULL);
+				if (rc != 0) {
+					cxgb_printf(sc->dip, CE_WARN,
+					    "failed to create interrupt event "
+					    "queue %u for port %u: %d.", j, i,
+					    rc);
+					t4_free_evt_iqs(sc);
+					return (rc);
+				}
+			}
 		}
+	}
+
+	return (0);
+}
+
+void
+t4_free_evt_iqs(struct adapter *sc)
+{
+	const uint_t port_count = sc->params.nports;
 
-		if (fl->flags & FL_MTX) {
-			mutex_destroy(&fl->lock);
-			fl->flags &= ~FL_MTX;
+	for (uint_t i = 0; i < port_count; i++) {
+		struct port_info *port = sc->port[i];
+
+		for (uint_t j = 0; j < sc->intr_queue_cfg.intr_per_port; j++) {
+			t4_free_iq(port, &port->intr_iqs[j]);
 		}
+	}
+
+	t4_free_iq(sc->port[0], &sc->sge.fwq);
+}
 
-		bzero(fl, sizeof (struct sge_fl));
+static int
+t4_alloc_rxq(struct port_info *pi, struct sge_rxq *rxq, uint_t q_idx)
+{
+	struct adapter *sc = pi->adapter;
+
+	rxq->port = pi;
+
+	t4_iq_params_t iqp = {
+		.tip_iq_type	= TIQT_ETH_RX,
+		.tip_tmr_idx	= pi->tmr_idx,
+		.tip_pktc_idx	= pi->pktc_idx,
+		.tip_qsize	= sc->props.qsize_rxq,
+		.tip_esize	= RX_IQ_ESIZE,
+		.tip_fl_qsize	= sc->props.qsize_rxq,
+		.tip_cong_chan	= t4_get_tp_ch_map(sc, pi->tx_chan),
+	};
+	t4_rxq_intr_assign(pi, q_idx, &iqp);
+	const int rc = t4_alloc_iq(pi, &iqp, &rxq->iq, &rxq->fl);
+	if (rc != 0) {
+		return (rc);
+	}
+
+	rxq->ksp = setup_rxq_kstats(pi, rxq, q_idx);
+	return (0);
+}
+
+static void
+t4_free_rxq(struct port_info *pi, struct sge_rxq *rxq)
+{
+	if (rxq->ksp != NULL) {
+		kstat_delete(rxq->ksp);
+		rxq->ksp = NULL;
 	}
 
-	return (0);
+	t4_free_iq(pi, &rxq->iq);
 }
 
-int
-t4_alloc_fwq(struct adapter *sc)
+static int
+t4_alloc_eq_base(struct port_info *pi, t4_sge_eq_t *eq)
 {
-	int rc, intr_idx;
-	struct sge_iq *fwq = &sc->sge.fwq;
+	struct adapter *sc = pi->adapter;
+	ASSERT0(eq->tse_flags);
+	mutex_init(&eq->tse_lock, NULL, MUTEX_DRIVER,
+	    DDI_INTR_PRI(sc->intr_pri));
+
+	/*
+	 * Make sure to account for the status page which sits at the end of the
+	 * hardware ring and may consume one or two credits.
+	 */
+	ASSERT3U(eq->tse_qsize, <=, T4_MAX_EQ_SIZE);
+	eq->tse_qsize_spg = eq->tse_qsize + sc->sge.eq_spg_len;
 
-	init_iq(fwq, sc, sc->sge.fwq_tmr_idx, sc->sge.fwq_pktc_idx,
-	    FW_IQ_QSIZE, FW_IQ_ESIZE);
-	fwq->flags |= IQ_INTR;	/* always */
-	intr_idx = sc->intr_count > 1 ? 1 : 0;
-	rc = alloc_iq_fl(sc->port[0], fwq, NULL, intr_idx, -1);
+	/*
+	 * We are allocating the "hardware" ring to hold the host credits, make
+	 * sure to use tse_qsize_spg to include the status page credits.
+	 */
+	const size_t len = eq->tse_qsize_spg * EQ_HC_SIZE;
+	int rc = alloc_desc_ring(sc, len, DDI_DMA_WRITE, &eq->tse_ring_dhdl,
+	    &eq->tse_ring_ahdl, &eq->tse_ring_ba, (caddr_t *)&eq->tse_ring);
 	if (rc != 0) {
-		cxgb_printf(sc->dip, CE_WARN,
-		    "failed to create firmware event queue: %d.", rc);
+		mutex_destroy(&eq->tse_lock);
 		return (rc);
 	}
+	eq->tse_flags |= EQ_ALLOC_HOST;
+
+	/*
+	 * We always use one credit less than the technical capacity to avoid
+	 * the situation where pidx == cidx which would indicate to the hardware
+	 * that the queue is empty.
+	 */
+	eq->tse_avail = eq->tse_qsize - 1;
+	eq->tse_pending = 0;
+	eq->tse_pidx = 0;
+	eq->tse_cidx = 0;
+	eq->tse_spg = t4_eq_credit(eq, eq->tse_qsize);
 
 	return (0);
 }
 
-int
-t4_free_fwq(struct adapter *sc)
-{
-	return (free_iq_fl(NULL, &sc->sge.fwq, NULL));
-}
+#define	UDB_DBS	(DOORBELL_UDB | DOORBELL_UDBWC | DOORBELL_WCWR)
 
-static int
-alloc_rxq(struct port_info *pi, struct sge_rxq *rxq, int intr_idx, int i)
+static void
+t4_alloc_eq_post(struct port_info *pi, t4_sge_eq_t *eq)
 {
-	int rc;
-
-	rxq->port = pi;
-	rc = alloc_iq_fl(pi, &rxq->iq, &rxq->fl, intr_idx,
-	    t4_get_tp_ch_map(pi->adapter, pi->tx_chan));
-	if (rc != 0)
-		return (rc);
+	struct adapter *sc = pi->adapter;
+	const boolean_t udb = (sc->doorbells & UDB_DBS) != 0;
+	ASSERT(eq->tse_flags & EQ_ALLOC_DEV);
 
-	rxq->ksp = setup_rxq_kstats(pi, rxq, i);
+	eq->tse_doorbells = sc->doorbells;
+	if (udb) {
+		uint64_t udb_offset;
+		uint_t udb_qid;
 
-	return (rc);
+		const int rc = t4_bar2_sge_qregs(sc, eq->tse_cntxt_id,
+		    T4_BAR2_QTYPE_EGRESS, 0, &udb_offset, &udb_qid);
+		if (rc == 0) {
+			eq->tse_udb = sc->bar2_ptr + udb_offset;
+			eq->tse_udb_qid = udb_qid;
+		} else {
+			eq->tse_doorbells &= ~UDB_DBS;
+			eq->tse_udb = NULL;
+			eq->tse_udb_qid = 0;
+		}
+	}
 }
 
 static int
-free_rxq(struct port_info *pi, struct sge_rxq *rxq)
+t4_eq_alloc_eth(struct port_info *pi, t4_sge_eq_t *eq)
 {
+	struct adapter *sc = pi->adapter;
 	int rc;
 
-	if (rxq->ksp != NULL) {
-		kstat_delete(rxq->ksp);
-		rxq->ksp = NULL;
+	if ((rc = t4_alloc_eq_base(pi, eq)) != 0) {
+		return (rc);
 	}
 
-	rc = free_iq_fl(pi, &rxq->iq, &rxq->fl);
-	if (rc == 0)
-		bzero(&rxq->fl, sizeof (*rxq) - offsetof(struct sge_rxq, fl));
-
-	return (rc);
-}
-
-static int
-eth_eq_alloc(struct adapter *sc, struct port_info *pi, struct sge_eq *eq)
-{
 	struct fw_eq_eth_cmd c = {
 		.op_to_vfn = BE_32(
 		    V_FW_CMD_OP(FW_EQ_ETH_CMD) |
@@ -1435,36 +1739,37 @@ eth_eq_alloc(struct adapter *sc, struct port_info *pi, struct sge_eq *eq)
 		    V_FW_EQ_ETH_CMD_VIID(pi->viid)),
 		.fetchszm_to_iqid = BE_32(
 		    V_FW_EQ_ETH_CMD_HOSTFCMODE(X_HOSTFCMODE_BOTH) |
-		    V_FW_EQ_ETH_CMD_PCIECHN(eq->tx_chan) |
+		    V_FW_EQ_ETH_CMD_PCIECHN(eq->tse_tx_chan) |
 		    F_FW_EQ_ETH_CMD_FETCHRO |
-		    V_FW_EQ_ETH_CMD_IQID(eq->iqid)),
+		    V_FW_EQ_ETH_CMD_IQID(eq->tse_iqid)),
 		.dcaen_to_eqsize = BE_32(
 		    V_FW_EQ_ETH_CMD_FBMIN(X_FETCHBURSTMIN_64B) |
 		    V_FW_EQ_ETH_CMD_FBMAX(X_FETCHBURSTMAX_512B) |
 		    V_FW_EQ_ETH_CMD_CIDXFTHRESH(X_CIDXFLUSHTHRESH_32) |
-		    V_FW_EQ_ETH_CMD_EQSIZE(eq->qsize)),
-		.eqaddr = BE_64(eq->ba),
+		    V_FW_EQ_ETH_CMD_EQSIZE(eq->tse_qsize_spg)),
+		.eqaddr = BE_64(eq->tse_ring_ba),
 	};
 
 	/*
-	 * The EQ is configured to send a notification for every 32 consumed
-	 * entries (X_CIDXFLUSHTHRESH_32).  In order to ensure timely
-	 * notification of entry consumption during slow periods when that
-	 * threshold may not be reached with regularity, two mechanisms exist:
+	 * The T4 is configured to send a notification for every 32 consumed
+	 * host credits (X_CIDXFLUSHTHRESH_32). During times of periodic Tx
+	 * traffic that threshold may not be reached with regularity, leaving
+	 * outstanding credits that cannot be reclaimed until more traffic is
+	 * sent. This can result in a situation where the device driver is
+	 * unable to shutdown and detach. To alleviate this problem two methods
+	 * may be employed:
 	 *
-	 * 1. The DBQ timer can be configured to fire (and send a notification)
-	 *    after a period when the EQ has gone idle.  This is available on T6
-	 *    and later adapters.
+	 * 1. The DBQ timer can be configured to arm and deliver a notification
+	 *    after the EQ has gone idle for a period of time. This is available
+	 *    on T6 and later adapters.
 	 *
-	 * 2. The CIDXFlushThresholdOverride flag will send a notification
-	 *    whenever a consumed entry causes CDIX==PIDX, even if the
-	 *    CIDXFlushThreshold has not been reached.
+	 * 2. The CIDXFlushThresholdOverride flag (also documented under
+	 *    FCThreshOverride flag in the T6 Programmers Guide) will send a
+	 *    notification whenever a consumed credit causes CDIX==PIDX, even if
+	 *    the CIDXFlushThreshold has not been reached.
 	 *
-	 * The DBQ timer is preferred, as it results in no additional
-	 * notifications when the EQ is kept busy with small transmissions.
-	 * Comparatively, flows of many short packets (like frequent ACKs) can
-	 * cause the CIDXFlushThresholdOverride mechanism to induce a
-	 * notification for every transmitted packet.
+	 * The DBQ timer is preferred, as it results in less notifications when
+	 * the EQ is kept busy with frequent single-credit transmissions.
 	 */
 	if (sc->flags & TAF_DBQ_TIMER) {
 		/* Configure the DBQ timer when it is available */
@@ -1476,117 +1781,78 @@ eth_eq_alloc(struct adapter *sc, struct port_info *pi, struct sge_eq *eq)
 		c.dcaen_to_eqsize |= BE_32(F_FW_EQ_ETH_CMD_CIDXFTHRESHO);
 	}
 
-	int rc = -t4_wr_mbox(sc, sc->mbox, &c, sizeof (c), &c);
+	rc = -t4_wr_mbox(sc, sc->mbox, &c, sizeof (c), &c);
 	if (rc != 0) {
 		cxgb_printf(pi->dip, CE_WARN,
 		    "failed to create Ethernet egress queue: %d", rc);
 		return (rc);
 	}
-	eq->flags |= EQ_ALLOCATED;
-
-	eq->cntxt_id = G_FW_EQ_ETH_CMD_EQID(BE_32(c.eqid_pkd));
-
-	*t4_eqmap_slot(sc, eq->cntxt_id) = eq;
-
-	return (rc);
-}
-
-static int
-alloc_eq(struct adapter *sc, struct port_info *pi, struct sge_eq *eq)
-{
-	int rc;
-	size_t len;
-
-	mutex_init(&eq->lock, NULL, MUTEX_DRIVER, DDI_INTR_PRI(sc->intr_pri));
-	eq->flags |= EQ_MTX;
-
-	len = eq->qsize * EQ_ESIZE;
-	rc = alloc_desc_ring(sc, len, DDI_DMA_WRITE, &eq->desc_dhdl,
-	    &eq->desc_ahdl, &eq->ba, (caddr_t *)&eq->desc);
-	if (rc != 0)
-		return (rc);
-
-	eq->cap = eq->qsize - sc->sge.stat_len / EQ_ESIZE;
-	eq->spg = (void *)&eq->desc[eq->cap];
-	eq->avail = eq->cap - 1;	/* one less to avoid cidx = pidx */
-	eq->pidx = eq->cidx = 0;
-	eq->doorbells = sc->doorbells;
-
-	rc = eth_eq_alloc(sc, pi, eq);
-	if (rc != 0) {
-		cxgb_printf(sc->dip, CE_WARN,
-		    "failed to allocate egress queue: %d", rc);
-	}
-
-	if (eq->doorbells & (DOORBELL_UDB | DOORBELL_UDBWC | DOORBELL_WCWR)) {
-		uint64_t udb_offset;
-		uint_t udb_qid;
+	eq->tse_cntxt_id = G_FW_EQ_ETH_CMD_EQID(BE_32(c.eqid_pkd));
+	*t4_eqmap_slot(sc, eq->tse_cntxt_id) = eq;
+	eq->tse_flags |= EQ_ALLOC_DEV;
 
-		rc = t4_bar2_sge_qregs(sc, eq->cntxt_id, T4_BAR2_QTYPE_EGRESS,
-		    0, &udb_offset, &udb_qid);
-
-		if (rc == 0) {
-			eq->udb = sc->bar2_ptr + udb_offset;
-			eq->udb_qid = udb_qid;
-		} else {
-			eq->doorbells &=
-			    ~(DOORBELL_UDB | DOORBELL_UDBWC | DOORBELL_WCWR);
-			eq->udb = NULL;
-			eq->udb_qid = 0;
-		}
-	}
+	t4_alloc_eq_post(pi, eq);
 
-	return (rc);
+	return (0);
 }
 
-static int
-free_eq(struct adapter *sc, struct sge_eq *eq)
+static void
+t4_free_eq(struct port_info *pi, t4_sge_eq_t *eq)
 {
-	int rc;
+	struct adapter *sc = pi->adapter;
 
-	if (eq->flags & EQ_ALLOCATED) {
-		rc = -t4_eth_eq_free(sc, sc->mbox, sc->pf, 0, eq->cntxt_id);
+	if (eq->tse_flags & EQ_ALLOC_DEV) {
+		int rc = -t4_eth_eq_free(sc, sc->mbox, sc->pf, 0,
+		    eq->tse_cntxt_id);
 		if (rc != 0) {
 			cxgb_printf(sc->dip, CE_WARN,
 			    "failed to free egress queue: %d", rc);
-			return (rc);
+			/*
+			 * Continue on with freeing operation, even though the
+			 * device resource will be effectively leaked.
+			 */
 		}
-		eq->flags &= ~EQ_ALLOCATED;
+		eq->tse_flags &= ~EQ_ALLOC_DEV;
 	}
 
-	if (eq->desc != NULL) {
-		(void) free_desc_ring(&eq->desc_dhdl, &eq->desc_ahdl);
-		eq->desc = NULL;
+	if (eq->tse_flags & EQ_ALLOC_HOST) {
+		(void) free_desc_ring(&eq->tse_ring_dhdl, &eq->tse_ring_ahdl);
+		eq->tse_ring = NULL;
+		eq->tse_ring_ba = 0;
+		eq->tse_spg = NULL;
+		mutex_destroy(&eq->tse_lock);
+		eq->tse_flags &= ~EQ_ALLOC_HOST;
 	}
 
-	if (eq->flags & EQ_MTX)
-		mutex_destroy(&eq->lock);
-
 	bzero(eq, sizeof (*eq));
-	return (0);
 }
 
 static int
-alloc_txq(struct port_info *pi, struct sge_txq *txq, int idx)
+t4_alloc_txq(struct port_info *pi, struct sge_txq *txq, int idx)
 {
-	int rc, i;
 	struct adapter *sc = pi->adapter;
-	struct sge_eq *eq = &txq->eq;
+	t4_sge_eq_t *eq = &txq->eq;
+	int rc;
 
-	rc = alloc_eq(sc, pi, eq);
-	if (rc != 0)
+	if ((rc = t4_eq_alloc_eth(pi, eq)) != 0) {
 		return (rc);
+	}
 
 	txq->port = pi;
-	txq->sdesc = kmem_zalloc(sizeof (struct tx_sdesc) * eq->cap, KM_SLEEP);
+	txq->sdesc = kmem_zalloc(sizeof (struct tx_sdesc) * eq->tse_qsize,
+	    KM_SLEEP);
 	txq->copy_threshold = tx_copy_threshold;
-	txq->txb_size = eq->qsize * txq->copy_threshold;
+	txq->txb_size = eq->tse_qsize * txq->copy_threshold;
 	rc = alloc_tx_copybuffer(sc, txq->txb_size, &txq->txb_dhdl,
 	    &txq->txb_ahdl, &txq->txb_ba, &txq->txb_va);
-	if (rc == 0)
+	if (rc != 0) {
+		txq->txb_size = 0;
+		txq->txb_avail = 0;
+		return (ENOMEM);
+	} else {
 		txq->txb_avail = txq->txb_size;
-	else
-		txq->txb_avail = txq->txb_size = 0;
+		eq->tse_flags |= EQ_ALLOC_DESC;
+	}
 
 	/*
 	 * TODO: is this too low?  Worst case would need around 4 times qsize
@@ -1594,10 +1860,10 @@ alloc_txq(struct port_info *pi, struct sge_txq *txq, int idx)
 	 * the SGL coming from a distinct DMA handle).  Increase tx_dhdl_total
 	 * if you see too many dma_hdl_failed.
 	 */
-	txq->tx_dhdl_total = eq->qsize * 2;
+	txq->tx_dhdl_total = eq->tse_qsize * 2;
 	txq->tx_dhdl = kmem_zalloc(sizeof (ddi_dma_handle_t) *
 	    txq->tx_dhdl_total, KM_SLEEP);
-	for (i = 0; i < txq->tx_dhdl_total; i++) {
+	for (uint_t i = 0; i < txq->tx_dhdl_total; i++) {
 		rc = ddi_dma_alloc_handle(sc->dip, &sc->sge.dma_attr_tx,
 		    DDI_DMA_SLEEP, 0, &txq->tx_dhdl[i]);
 		if (rc != DDI_SUCCESS) {
@@ -1611,15 +1877,13 @@ alloc_txq(struct port_info *pi, struct sge_txq *txq, int idx)
 
 	txq->ksp = setup_txq_kstats(pi, txq, idx);
 
-	return (rc);
+	return (0);
 }
 
-static int
-free_txq(struct port_info *pi, struct sge_txq *txq)
+static void
+t4_free_txq(struct port_info *pi, struct sge_txq *txq)
 {
-	int i;
-	struct adapter *sc = pi->adapter;
-	struct sge_eq *eq = &txq->eq;
+	t4_sge_eq_t *eq = &txq->eq;
 
 	if (txq->ksp != NULL) {
 		kstat_delete(txq->ksp);
@@ -1632,14 +1896,13 @@ free_txq(struct port_info *pi, struct sge_txq *txq)
 	}
 
 	if (txq->sdesc != NULL) {
-		struct tx_sdesc *sd;
 		ddi_dma_handle_t hdl;
 
 		TXQ_LOCK(txq);
-		while (eq->cidx != eq->pidx) {
-			sd = &txq->sdesc[eq->cidx];
+		while (eq->tse_cidx != eq->tse_pidx) {
+			struct tx_sdesc *sd = &txq->sdesc[eq->tse_cidx];
 
-			for (i = sd->hdls_used; i; i--) {
+			for (uint_t i = sd->hdls_used; i != 0; i--) {
 				hdl = txq->tx_dhdl[txq->tx_dhdl_cidx];
 				(void) ddi_dma_unbind_handle(hdl);
 				if (++txq->tx_dhdl_cidx == txq->tx_dhdl_total)
@@ -1650,22 +1913,23 @@ free_txq(struct port_info *pi, struct sge_txq *txq)
 			freemsgchain(sd->mp_head);
 			sd->mp_head = sd->mp_tail = NULL;
 
-			eq->cidx += sd->desc_used;
-			if (eq->cidx >= eq->cap)
-				eq->cidx -= eq->cap;
+			eq->tse_cidx += sd->credits_used;
+			if (eq->tse_cidx >= eq->tse_qsize)
+				eq->tse_cidx -= eq->tse_qsize;
 
-			txq->txb_avail += txq->txb_used;
+			txq->txb_avail += sd->txb_used;
 		}
 		ASSERT(txq->tx_dhdl_cidx == txq->tx_dhdl_pidx);
 		ASSERT(txq->txb_avail == txq->txb_size);
 		TXQ_UNLOCK(txq);
 
-		kmem_free(txq->sdesc, sizeof (struct tx_sdesc) * eq->cap);
+		kmem_free(txq->sdesc, sizeof (struct tx_sdesc) * eq->tse_qsize);
 		txq->sdesc = NULL;
+		eq->tse_flags &= ~EQ_ALLOC_DESC;
 	}
 
 	if (txq->tx_dhdl != NULL) {
-		for (i = 0; i < txq->tx_dhdl_total; i++) {
+		for (uint_t i = 0; i < txq->tx_dhdl_total; i++) {
 			if (txq->tx_dhdl[i] != NULL)
 				ddi_dma_free_handle(&txq->tx_dhdl[i]);
 		}
@@ -1674,10 +1938,9 @@ free_txq(struct port_info *pi, struct sge_txq *txq)
 		txq->tx_dhdl = NULL;
 	}
 
-	(void) free_eq(sc, &txq->eq);
+	t4_free_eq(pi, &txq->eq);
 
 	bzero(txq, sizeof (*txq));
-	return (0);
 }
 
 /*
@@ -1799,27 +2062,80 @@ alloc_tx_copybuffer(struct adapter *sc, size_t len,
 	    acc_attr, dma_attr, dma_hdl, acc_hdl, pba, pva));
 }
 
+/*
+ * Fetch next valid (if any) response from adapter in IQ.  Returns `true` if
+ * rsp_ctrl data read into `ctrl` has generation bit state matching IQ
+ * expectation for a new entry.
+ *
+ * This does not advance cidx, which is left to a subsequent call to
+ * t4_iq_next_entry().
+ */
 static inline bool
-is_new_response(const struct sge_iq *iq, struct rsp_ctrl **ctrl)
+t4_get_new_rsp(const t4_sge_iq_t *iq, struct rsp_ctrl *ctrl)
 {
-	(void) ddi_dma_sync(iq->dhdl, (uintptr_t)iq->cdesc -
-	    (uintptr_t)iq->desc, iq->esize, DDI_DMA_SYNC_FORKERNEL);
+	(void) ddi_dma_sync(iq->tsi_desc_dhdl, 0, 0, DDI_DMA_SYNC_FORKERNEL);
 
-	*ctrl = (void *)((uintptr_t)iq->cdesc +
-	    (iq->esize - sizeof (struct rsp_ctrl)));
-
-	return ((((*ctrl)->u.type_gen >> S_RSPD_GEN) == iq->gen));
+	*ctrl = *(struct rsp_ctrl *)
+	    ((caddr_t)iq->tsi_cdesc + (iq->tsi_esize_bytes -
+	    sizeof (struct rsp_ctrl)));
+	return ((ctrl->u.type_gen & F_RSPD_GEN) == iq->tsi_gen);
 }
 
+/*
+ * Advance IQ consumer index, wrapping (and toggling generation bit) when the
+ * end of the ring is reached.
+ */
 static inline void
-iq_next(struct sge_iq *iq)
+t4_iq_next_entry(t4_sge_iq_t *iq)
+{
+	iq->tsi_cdesc = (void *) ((caddr_t)iq->tsi_cdesc + iq->tsi_esize_bytes);
+	if (++iq->tsi_cidx == iq->tsi_cap) {
+		iq->tsi_cidx = 0;
+		iq->tsi_gen ^= F_RSPD_GEN;
+		iq->tsi_cdesc = iq->tsi_desc;
+	}
+}
+
+static inline bool
+t4_fl_running_low(const struct sge_fl *fl)
+{
+	return (fl->bufs_avail <= fl->bufs_lowat);
+}
+
+static inline bool
+t4_fl_not_running_low(const struct sge_fl *fl)
+{
+	return (fl->bufs_avail >= (2 * fl->bufs_lowat));
+}
+
+static inline uint_t
+t4_fl_advance_cidx(struct sge_fl *fl)
 {
-	iq->cdesc = (void *) ((uintptr_t)iq->cdesc + iq->esize);
-	if (++iq->cidx == iq->qsize - 1) {
-		iq->cidx = 0;
-		iq->gen ^= 1;
-		iq->cdesc = iq->desc;
+	t4_sge_eq_t *eq = &fl->eq;
+
+	FL_LOCK_ASSERT_OWNED(fl);
+	ASSERT3U(fl->cidx_sdesc, <, FL_BUF_PTR_PER_HC);
+	ASSERT3U(eq->tse_cidx, <, eq->tse_qsize);
+
+	fl->cidx_sdesc++;
+	if (fl->cidx_sdesc == FL_BUF_PTR_PER_HC) {
+		fl->cidx_sdesc = 0;
+		eq->tse_cidx++;
+		if (eq->tse_cidx == eq->tse_qsize) {
+			eq->tse_cidx = 0;
+		}
+		return (1);
 	}
+	return (0);
+}
+
+static inline struct fl_sdesc *
+t4_fl_sdesc(struct sge_fl *fl, uint_t eq_idx, uint_t sdesc_idx)
+{
+	ASSERT(sdesc_idx < FL_BUF_PTR_PER_HC);
+	const uint_t idx = (eq_idx * FL_BUF_PTR_PER_HC) + sdesc_idx;
+
+	return (&fl->sdesc[idx]);
 }
 
 /*
@@ -1828,19 +2144,24 @@ iq_next(struct sge_iq *iq)
  * Returns non-zero to indicate that it should be added to the list of starving
  * freelists.
  */
-static int
-refill_fl(struct adapter *sc, struct sge_fl *fl, int nbufs)
+static bool
+t4_fl_refill(struct sge_fl *fl, uint_t nbufs)
 {
-	uint64_t *d = &fl->desc[fl->pidx];
-	struct fl_sdesc *sd = &fl->sdesc[fl->pidx];
+	struct adapter *sc = t4_fl_to_iq(fl)->tsi_adapter;
+	t4_sge_eq_t *eq = &fl->eq;
 
 	FL_LOCK_ASSERT_OWNED(fl);
-	ASSERT(nbufs >= 0);
 
-	if (nbufs > fl->needed)
-		nbufs = fl->needed;
+	/*
+	 * We refill up to nbufs, but maybe less if there are not that many
+	 * outstanding.
+	 */
+	nbufs = MIN(nbufs, fl->bufs_cap - fl->bufs_avail);
+	while (nbufs != 0 && eq->tse_avail != 0) {
+		struct fl_desc *fld = t4_eq_credit(eq, eq->tse_pidx);
+		struct fl_sdesc *sd = t4_fl_sdesc(fl, eq->tse_pidx,
+		    fl->pidx_sdesc);
 
-	while (nbufs--) {
 		if (sd->rxb != NULL) {
 			if (sd->rxb->ref_cnt == 1) {
 				/*
@@ -1860,9 +2181,9 @@ refill_fl(struct adapter *sc, struct sge_fl *fl, int nbufs)
 				 * Either way the bus address in the descriptor
 				 * ring is already valid.
 				 */
-				ASSERT(*d == cpu_to_be64(sd->rxb->ba));
-				d++;
-				goto recycled;
+				ASSERT3U(fld->dptr[fl->pidx_sdesc], ==,
+				    BE_64(sd->rxb->ba));
+				fl->stats.rxb_recycle++;
 			} else {
 				/*
 				 * Buffer still in use and we need a
@@ -1870,89 +2191,113 @@ refill_fl(struct adapter *sc, struct sge_fl *fl, int nbufs)
 				 * on the existing buffer.
 				 */
 				rxbuf_free(sd->rxb);
+				sd->rxb = NULL;
 			}
 		}
 
-		sd->rxb = rxbuf_alloc(sc->sge.rxbuf_cache, KM_NOSLEEP, 1);
-		if (sd->rxb == NULL)
-			break;
-		*d++ = cpu_to_be64(sd->rxb->ba);
-
-recycled:	fl->pending++;
-		sd++;
-		fl->needed--;
-		if (++fl->pidx == fl->cap) {
-			fl->pidx = 0;
-			sd = fl->sdesc;
-			d = fl->desc;
+		if (sd->rxb == NULL) {
+			sd->rxb = rxbuf_alloc(sc->sge.rxbuf_cache, KM_NOSLEEP);
+			if (sd->rxb == NULL) {
+				fl->stats.rxb_alloc_fail++;
+				break;
+			}
+			fl->stats.rxb_alloc++;
+		}
+		fld->dptr[fl->pidx_sdesc] = BE_64(sd->rxb->ba);
+
+		nbufs--;
+		fl->bufs_avail++;
+		fl->pidx_sdesc++;
+		if (fl->pidx_sdesc == FL_BUF_PTR_PER_HC) {
+			/*
+			 * The host credit is filled. It is now ready to be
+			 * posted to the device.
+			 */
+			fl->pidx_sdesc = 0;
+			eq->tse_pending++;
+			eq->tse_avail--;
+			eq->tse_pidx++;
+			if (eq->tse_pidx == eq->tse_qsize) {
+				eq->tse_pidx = 0;
+			}
 		}
 	}
 
-	if (fl->pending >= 8)
-		ring_fl_db(sc, fl);
+	if (eq->tse_pending != 0) {
+		t4_fl_ring_db(fl);
+	}
 
-	return (FL_RUNNING_LOW(fl) && !(fl->flags & FL_STARVING));
+	return (t4_fl_running_low(fl));
 }
 
-#ifndef TAILQ_FOREACH_SAFE
-#define	TAILQ_FOREACH_SAFE(var, head, field, tvar)			\
-	for ((var) = TAILQ_FIRST((head));				\
-	    (var) && ((tvar) = TAILQ_NEXT((var), field), 1);		\
-	    (var) = (tvar))
-#endif
+static clock_t t4_sfl_period_us = 100000;
+
+static void
+t4_sfl_reschedule(struct adapter *sc)
+{
+	ASSERT(MUTEX_HELD(&sc->sfl_lock));
+	ASSERT(!list_is_empty(&sc->sfl_list));
+
+	sc->sfl_timer = timeout(t4_sfl_process, sc,
+	    drv_usectohz(t4_sfl_period_us));
+}
 
 /*
  * Attempt to refill all starving freelists.
  */
 static void
-refill_sfl(void *arg)
+t4_sfl_process(void *arg)
 {
 	struct adapter *sc = arg;
-	struct sge_fl *fl, *fl_temp;
 
 	mutex_enter(&sc->sfl_lock);
-	TAILQ_FOREACH_SAFE(fl, &sc->sfl, link, fl_temp) {
+	struct sge_fl *fl = list_head(&sc->sfl_list);
+	while (fl != NULL) {
+		struct sge_fl *next = list_next(&sc->sfl_list, fl);
+
 		FL_LOCK(fl);
-		(void) refill_fl(sc, fl, 64);
-		if (FL_NOT_RUNNING_LOW(fl) || fl->flags & FL_DOOMED) {
-			TAILQ_REMOVE(&sc->sfl, fl, link);
-			fl->flags &= ~FL_STARVING;
+		(void) t4_fl_refill(fl, 64);
+		if (t4_fl_not_running_low(fl) || fl->sfl_flags & SFL_DOOMED) {
+			list_remove(&sc->sfl_list, fl);
+			fl->sfl_flags &= ~SFL_STARVING;
 		}
 		FL_UNLOCK(fl);
+		fl = next;
 	}
 
-	if (!TAILQ_EMPTY(&sc->sfl) != 0)
-		sc->sfl_timer =  timeout(refill_sfl, sc, drv_usectohz(100000));
+	if (!list_is_empty(&sc->sfl_list)) {
+		t4_sfl_reschedule(sc);
+	}
 	mutex_exit(&sc->sfl_lock);
 }
 
 static void
-add_fl_to_sfl(struct adapter *sc, struct sge_fl *fl)
+t4_sfl_enqueue(struct adapter *sc, struct sge_fl *fl)
 {
 	mutex_enter(&sc->sfl_lock);
 	FL_LOCK(fl);
-	if ((fl->flags & FL_DOOMED) == 0) {
-		if (TAILQ_EMPTY(&sc->sfl) != 0) {
-			sc->sfl_timer = timeout(refill_sfl, sc,
-			    drv_usectohz(100000));
+	if ((fl->sfl_flags & (SFL_DOOMED | SFL_STARVING)) == 0) {
+		const bool was_empty = list_is_empty(&sc->sfl_list);
+
+		fl->sfl_flags |= SFL_STARVING;
+		list_insert_tail(&sc->sfl_list, fl);
+		if (was_empty) {
+			t4_sfl_reschedule(sc);
 		}
-		fl->flags |= FL_STARVING;
-		TAILQ_INSERT_TAIL(&sc->sfl, fl, link);
 	}
 	FL_UNLOCK(fl);
 	mutex_exit(&sc->sfl_lock);
 }
 
 static void
-free_fl_bufs(struct sge_fl *fl)
+t4_fl_free_bufs(struct sge_fl *fl)
 {
-	struct fl_sdesc *sd;
-	unsigned int i;
+	t4_sge_eq_t *eq = &fl->eq;
 
-	FL_LOCK_ASSERT_OWNED(fl);
+	EQ_LOCK_ASSERT_OWNED(eq);
 
-	for (i = 0; i < fl->cap; i++) {
-		sd = &fl->sdesc[i];
+	for (uint_t i = 0; i < eq->tse_qsize * FL_BUF_PTR_PER_HC; i++) {
+		struct fl_sdesc *sd = &fl->sdesc[i];
 
 		if (sd->rxb != NULL) {
 			rxbuf_free(sd->rxb);
